package com.neusoft.smart.pos.card.persistent.domain;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class CardExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer offset;

    private Integer limit;

    public CardExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
        this.offset = null;
        this.limit = null;
    }

    public Integer getOffset() {
        return this.offset;
    }

    public void setOffset(Integer offset) {
        this.offset = offset;
    }

    public Integer getLimit() {
        return this.limit;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public CardExample page(int offset, int limit) {
        this.offset = offset;
        this.limit = limit;
        return this;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andCardIdIsNull() {
            addCriterion("card_id is null");
            return (Criteria) this;
        }

        public Criteria andCardIdIsNotNull() {
            addCriterion("card_id is not null");
            return (Criteria) this;
        }

        public Criteria andCardIdEqualTo(Integer value) {
            addCriterion("card_id =", value, "cardId");
            return (Criteria) this;
        }

        public Criteria andCardIdNotEqualTo(Integer value) {
            addCriterion("card_id <>", value, "cardId");
            return (Criteria) this;
        }

        public Criteria andCardIdGreaterThan(Integer value) {
            addCriterion("card_id >", value, "cardId");
            return (Criteria) this;
        }

        public Criteria andCardIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("card_id >=", value, "cardId");
            return (Criteria) this;
        }

        public Criteria andCardIdLessThan(Integer value) {
            addCriterion("card_id <", value, "cardId");
            return (Criteria) this;
        }

        public Criteria andCardIdLessThanOrEqualTo(Integer value) {
            addCriterion("card_id <=", value, "cardId");
            return (Criteria) this;
        }

        public Criteria andCardIdIn(List<Integer> values) {
            addCriterion("card_id in", values, "cardId");
            return (Criteria) this;
        }

        public Criteria andCardIdNotIn(List<Integer> values) {
            addCriterion("card_id not in", values, "cardId");
            return (Criteria) this;
        }

        public Criteria andCardIdBetween(Integer value1, Integer value2) {
            addCriterion("card_id between", value1, value2, "cardId");
            return (Criteria) this;
        }

        public Criteria andCardIdNotBetween(Integer value1, Integer value2) {
            addCriterion("card_id not between", value1, value2, "cardId");
            return (Criteria) this;
        }

        public Criteria andCardTypeIsNull() {
            addCriterion("card_type is null");
            return (Criteria) this;
        }

        public Criteria andCardTypeIsNotNull() {
            addCriterion("card_type is not null");
            return (Criteria) this;
        }

        public Criteria andCardTypeEqualTo(Integer value) {
            addCriterion("card_type =", value, "cardType");
            return (Criteria) this;
        }

        public Criteria andCardTypeNotEqualTo(Integer value) {
            addCriterion("card_type <>", value, "cardType");
            return (Criteria) this;
        }

        public Criteria andCardTypeGreaterThan(Integer value) {
            addCriterion("card_type >", value, "cardType");
            return (Criteria) this;
        }

        public Criteria andCardTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("card_type >=", value, "cardType");
            return (Criteria) this;
        }

        public Criteria andCardTypeLessThan(Integer value) {
            addCriterion("card_type <", value, "cardType");
            return (Criteria) this;
        }

        public Criteria andCardTypeLessThanOrEqualTo(Integer value) {
            addCriterion("card_type <=", value, "cardType");
            return (Criteria) this;
        }

        public Criteria andCardTypeIn(List<Integer> values) {
            addCriterion("card_type in", values, "cardType");
            return (Criteria) this;
        }

        public Criteria andCardTypeNotIn(List<Integer> values) {
            addCriterion("card_type not in", values, "cardType");
            return (Criteria) this;
        }

        public Criteria andCardTypeBetween(Integer value1, Integer value2) {
            addCriterion("card_type between", value1, value2, "cardType");
            return (Criteria) this;
        }

        public Criteria andCardTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("card_type not between", value1, value2, "cardType");
            return (Criteria) this;
        }

        public Criteria andCardNumIsNull() {
            addCriterion("card_num is null");
            return (Criteria) this;
        }

        public Criteria andCardNumIsNotNull() {
            addCriterion("card_num is not null");
            return (Criteria) this;
        }

        public Criteria andCardNumEqualTo(String value) {
            addCriterion("card_num =", value, "cardNum");
            return (Criteria) this;
        }

        public Criteria andCardNumNotEqualTo(String value) {
            addCriterion("card_num <>", value, "cardNum");
            return (Criteria) this;
        }

        public Criteria andCardNumGreaterThan(String value) {
            addCriterion("card_num >", value, "cardNum");
            return (Criteria) this;
        }

        public Criteria andCardNumGreaterThanOrEqualTo(String value) {
            addCriterion("card_num >=", value, "cardNum");
            return (Criteria) this;
        }

        public Criteria andCardNumLessThan(String value) {
            addCriterion("card_num <", value, "cardNum");
            return (Criteria) this;
        }

        public Criteria andCardNumLessThanOrEqualTo(String value) {
            addCriterion("card_num <=", value, "cardNum");
            return (Criteria) this;
        }

        public Criteria andCardNumLike(String value) {
            addCriterion("card_num like", value, "cardNum");
            return (Criteria) this;
        }

        public Criteria andCardNumNotLike(String value) {
            addCriterion("card_num not like", value, "cardNum");
            return (Criteria) this;
        }

        public Criteria andCardNumIn(List<String> values) {
            addCriterion("card_num in", values, "cardNum");
            return (Criteria) this;
        }

        public Criteria andCardNumNotIn(List<String> values) {
            addCriterion("card_num not in", values, "cardNum");
            return (Criteria) this;
        }

        public Criteria andCardNumBetween(String value1, String value2) {
            addCriterion("card_num between", value1, value2, "cardNum");
            return (Criteria) this;
        }

        public Criteria andCardNumNotBetween(String value1, String value2) {
            addCriterion("card_num not between", value1, value2, "cardNum");
            return (Criteria) this;
        }

        public Criteria andCardAnotherIdIsNull() {
            addCriterion("card_another_id is null");
            return (Criteria) this;
        }

        public Criteria andCardAnotherIdIsNotNull() {
            addCriterion("card_another_id is not null");
            return (Criteria) this;
        }

        public Criteria andCardAnotherIdEqualTo(String value) {
            addCriterion("card_another_id =", value, "cardAnotherId");
            return (Criteria) this;
        }

        public Criteria andCardAnotherIdNotEqualTo(String value) {
            addCriterion("card_another_id <>", value, "cardAnotherId");
            return (Criteria) this;
        }

        public Criteria andCardAnotherIdGreaterThan(String value) {
            addCriterion("card_another_id >", value, "cardAnotherId");
            return (Criteria) this;
        }

        public Criteria andCardAnotherIdGreaterThanOrEqualTo(String value) {
            addCriterion("card_another_id >=", value, "cardAnotherId");
            return (Criteria) this;
        }

        public Criteria andCardAnotherIdLessThan(String value) {
            addCriterion("card_another_id <", value, "cardAnotherId");
            return (Criteria) this;
        }

        public Criteria andCardAnotherIdLessThanOrEqualTo(String value) {
            addCriterion("card_another_id <=", value, "cardAnotherId");
            return (Criteria) this;
        }

        public Criteria andCardAnotherIdLike(String value) {
            addCriterion("card_another_id like", value, "cardAnotherId");
            return (Criteria) this;
        }

        public Criteria andCardAnotherIdNotLike(String value) {
            addCriterion("card_another_id not like", value, "cardAnotherId");
            return (Criteria) this;
        }

        public Criteria andCardAnotherIdIn(List<String> values) {
            addCriterion("card_another_id in", values, "cardAnotherId");
            return (Criteria) this;
        }

        public Criteria andCardAnotherIdNotIn(List<String> values) {
            addCriterion("card_another_id not in", values, "cardAnotherId");
            return (Criteria) this;
        }

        public Criteria andCardAnotherIdBetween(String value1, String value2) {
            addCriterion("card_another_id between", value1, value2, "cardAnotherId");
            return (Criteria) this;
        }

        public Criteria andCardAnotherIdNotBetween(String value1, String value2) {
            addCriterion("card_another_id not between", value1, value2, "cardAnotherId");
            return (Criteria) this;
        }

        public Criteria andCardOtherIdIsNull() {
            addCriterion("card_other_id is null");
            return (Criteria) this;
        }

        public Criteria andCardOtherIdIsNotNull() {
            addCriterion("card_other_id is not null");
            return (Criteria) this;
        }

        public Criteria andCardOtherIdEqualTo(String value) {
            addCriterion("card_other_id =", value, "cardOtherId");
            return (Criteria) this;
        }

        public Criteria andCardOtherIdNotEqualTo(String value) {
            addCriterion("card_other_id <>", value, "cardOtherId");
            return (Criteria) this;
        }

        public Criteria andCardOtherIdGreaterThan(String value) {
            addCriterion("card_other_id >", value, "cardOtherId");
            return (Criteria) this;
        }

        public Criteria andCardOtherIdGreaterThanOrEqualTo(String value) {
            addCriterion("card_other_id >=", value, "cardOtherId");
            return (Criteria) this;
        }

        public Criteria andCardOtherIdLessThan(String value) {
            addCriterion("card_other_id <", value, "cardOtherId");
            return (Criteria) this;
        }

        public Criteria andCardOtherIdLessThanOrEqualTo(String value) {
            addCriterion("card_other_id <=", value, "cardOtherId");
            return (Criteria) this;
        }

        public Criteria andCardOtherIdLike(String value) {
            addCriterion("card_other_id like", value, "cardOtherId");
            return (Criteria) this;
        }

        public Criteria andCardOtherIdNotLike(String value) {
            addCriterion("card_other_id not like", value, "cardOtherId");
            return (Criteria) this;
        }

        public Criteria andCardOtherIdIn(List<String> values) {
            addCriterion("card_other_id in", values, "cardOtherId");
            return (Criteria) this;
        }

        public Criteria andCardOtherIdNotIn(List<String> values) {
            addCriterion("card_other_id not in", values, "cardOtherId");
            return (Criteria) this;
        }

        public Criteria andCardOtherIdBetween(String value1, String value2) {
            addCriterion("card_other_id between", value1, value2, "cardOtherId");
            return (Criteria) this;
        }

        public Criteria andCardOtherIdNotBetween(String value1, String value2) {
            addCriterion("card_other_id not between", value1, value2, "cardOtherId");
            return (Criteria) this;
        }

        public Criteria andCardPasswordIsNull() {
            addCriterion("card_password is null");
            return (Criteria) this;
        }

        public Criteria andCardPasswordIsNotNull() {
            addCriterion("card_password is not null");
            return (Criteria) this;
        }

        public Criteria andCardPasswordEqualTo(String value) {
            addCriterion("card_password =", value, "cardPassword");
            return (Criteria) this;
        }

        public Criteria andCardPasswordNotEqualTo(String value) {
            addCriterion("card_password <>", value, "cardPassword");
            return (Criteria) this;
        }

        public Criteria andCardPasswordGreaterThan(String value) {
            addCriterion("card_password >", value, "cardPassword");
            return (Criteria) this;
        }

        public Criteria andCardPasswordGreaterThanOrEqualTo(String value) {
            addCriterion("card_password >=", value, "cardPassword");
            return (Criteria) this;
        }

        public Criteria andCardPasswordLessThan(String value) {
            addCriterion("card_password <", value, "cardPassword");
            return (Criteria) this;
        }

        public Criteria andCardPasswordLessThanOrEqualTo(String value) {
            addCriterion("card_password <=", value, "cardPassword");
            return (Criteria) this;
        }

        public Criteria andCardPasswordLike(String value) {
            addCriterion("card_password like", value, "cardPassword");
            return (Criteria) this;
        }

        public Criteria andCardPasswordNotLike(String value) {
            addCriterion("card_password not like", value, "cardPassword");
            return (Criteria) this;
        }

        public Criteria andCardPasswordIn(List<String> values) {
            addCriterion("card_password in", values, "cardPassword");
            return (Criteria) this;
        }

        public Criteria andCardPasswordNotIn(List<String> values) {
            addCriterion("card_password not in", values, "cardPassword");
            return (Criteria) this;
        }

        public Criteria andCardPasswordBetween(String value1, String value2) {
            addCriterion("card_password between", value1, value2, "cardPassword");
            return (Criteria) this;
        }

        public Criteria andCardPasswordNotBetween(String value1, String value2) {
            addCriterion("card_password not between", value1, value2, "cardPassword");
            return (Criteria) this;
        }

        public Criteria andCardPointIsNull() {
            addCriterion("card_point is null");
            return (Criteria) this;
        }

        public Criteria andCardPointIsNotNull() {
            addCriterion("card_point is not null");
            return (Criteria) this;
        }

        public Criteria andCardPointEqualTo(Integer value) {
            addCriterion("card_point =", value, "cardPoint");
            return (Criteria) this;
        }

        public Criteria andCardPointNotEqualTo(Integer value) {
            addCriterion("card_point <>", value, "cardPoint");
            return (Criteria) this;
        }

        public Criteria andCardPointGreaterThan(Integer value) {
            addCriterion("card_point >", value, "cardPoint");
            return (Criteria) this;
        }

        public Criteria andCardPointGreaterThanOrEqualTo(Integer value) {
            addCriterion("card_point >=", value, "cardPoint");
            return (Criteria) this;
        }

        public Criteria andCardPointLessThan(Integer value) {
            addCriterion("card_point <", value, "cardPoint");
            return (Criteria) this;
        }

        public Criteria andCardPointLessThanOrEqualTo(Integer value) {
            addCriterion("card_point <=", value, "cardPoint");
            return (Criteria) this;
        }

        public Criteria andCardPointIn(List<Integer> values) {
            addCriterion("card_point in", values, "cardPoint");
            return (Criteria) this;
        }

        public Criteria andCardPointNotIn(List<Integer> values) {
            addCriterion("card_point not in", values, "cardPoint");
            return (Criteria) this;
        }

        public Criteria andCardPointBetween(Integer value1, Integer value2) {
            addCriterion("card_point between", value1, value2, "cardPoint");
            return (Criteria) this;
        }

        public Criteria andCardPointNotBetween(Integer value1, Integer value2) {
            addCriterion("card_point not between", value1, value2, "cardPoint");
            return (Criteria) this;
        }

        public Criteria andCardBalanceIsNull() {
            addCriterion("card_balance is null");
            return (Criteria) this;
        }

        public Criteria andCardBalanceIsNotNull() {
            addCriterion("card_balance is not null");
            return (Criteria) this;
        }

        public Criteria andCardBalanceEqualTo(Long value) {
            addCriterion("card_balance =", value, "cardBalance");
            return (Criteria) this;
        }

        public Criteria andCardBalanceNotEqualTo(Long value) {
            addCriterion("card_balance <>", value, "cardBalance");
            return (Criteria) this;
        }

        public Criteria andCardBalanceGreaterThan(Long value) {
            addCriterion("card_balance >", value, "cardBalance");
            return (Criteria) this;
        }

        public Criteria andCardBalanceGreaterThanOrEqualTo(Long value) {
            addCriterion("card_balance >=", value, "cardBalance");
            return (Criteria) this;
        }

        public Criteria andCardBalanceLessThan(Long value) {
            addCriterion("card_balance <", value, "cardBalance");
            return (Criteria) this;
        }

        public Criteria andCardBalanceLessThanOrEqualTo(Long value) {
            addCriterion("card_balance <=", value, "cardBalance");
            return (Criteria) this;
        }

        public Criteria andCardBalanceIn(List<Long> values) {
            addCriterion("card_balance in", values, "cardBalance");
            return (Criteria) this;
        }

        public Criteria andCardBalanceNotIn(List<Long> values) {
            addCriterion("card_balance not in", values, "cardBalance");
            return (Criteria) this;
        }

        public Criteria andCardBalanceBetween(Long value1, Long value2) {
            addCriterion("card_balance between", value1, value2, "cardBalance");
            return (Criteria) this;
        }

        public Criteria andCardBalanceNotBetween(Long value1, Long value2) {
            addCriterion("card_balance not between", value1, value2, "cardBalance");
            return (Criteria) this;
        }

        public Criteria andCardImageIsNull() {
            addCriterion("card_image is null");
            return (Criteria) this;
        }

        public Criteria andCardImageIsNotNull() {
            addCriterion("card_image is not null");
            return (Criteria) this;
        }

        public Criteria andCardImageEqualTo(String value) {
            addCriterion("card_image =", value, "cardImage");
            return (Criteria) this;
        }

        public Criteria andCardImageNotEqualTo(String value) {
            addCriterion("card_image <>", value, "cardImage");
            return (Criteria) this;
        }

        public Criteria andCardImageGreaterThan(String value) {
            addCriterion("card_image >", value, "cardImage");
            return (Criteria) this;
        }

        public Criteria andCardImageGreaterThanOrEqualTo(String value) {
            addCriterion("card_image >=", value, "cardImage");
            return (Criteria) this;
        }

        public Criteria andCardImageLessThan(String value) {
            addCriterion("card_image <", value, "cardImage");
            return (Criteria) this;
        }

        public Criteria andCardImageLessThanOrEqualTo(String value) {
            addCriterion("card_image <=", value, "cardImage");
            return (Criteria) this;
        }

        public Criteria andCardImageLike(String value) {
            addCriterion("card_image like", value, "cardImage");
            return (Criteria) this;
        }

        public Criteria andCardImageNotLike(String value) {
            addCriterion("card_image not like", value, "cardImage");
            return (Criteria) this;
        }

        public Criteria andCardImageIn(List<String> values) {
            addCriterion("card_image in", values, "cardImage");
            return (Criteria) this;
        }

        public Criteria andCardImageNotIn(List<String> values) {
            addCriterion("card_image not in", values, "cardImage");
            return (Criteria) this;
        }

        public Criteria andCardImageBetween(String value1, String value2) {
            addCriterion("card_image between", value1, value2, "cardImage");
            return (Criteria) this;
        }

        public Criteria andCardImageNotBetween(String value1, String value2) {
            addCriterion("card_image not between", value1, value2, "cardImage");
            return (Criteria) this;
        }

        public Criteria andBeanNameIsNull() {
            addCriterion("bean_name is null");
            return (Criteria) this;
        }

        public Criteria andBeanNameIsNotNull() {
            addCriterion("bean_name is not null");
            return (Criteria) this;
        }

        public Criteria andBeanNameEqualTo(String value) {
            addCriterion("bean_name =", value, "beanName");
            return (Criteria) this;
        }

        public Criteria andBeanNameNotEqualTo(String value) {
            addCriterion("bean_name <>", value, "beanName");
            return (Criteria) this;
        }

        public Criteria andBeanNameGreaterThan(String value) {
            addCriterion("bean_name >", value, "beanName");
            return (Criteria) this;
        }

        public Criteria andBeanNameGreaterThanOrEqualTo(String value) {
            addCriterion("bean_name >=", value, "beanName");
            return (Criteria) this;
        }

        public Criteria andBeanNameLessThan(String value) {
            addCriterion("bean_name <", value, "beanName");
            return (Criteria) this;
        }

        public Criteria andBeanNameLessThanOrEqualTo(String value) {
            addCriterion("bean_name <=", value, "beanName");
            return (Criteria) this;
        }

        public Criteria andBeanNameLike(String value) {
            addCriterion("bean_name like", value, "beanName");
            return (Criteria) this;
        }

        public Criteria andBeanNameNotLike(String value) {
            addCriterion("bean_name not like", value, "beanName");
            return (Criteria) this;
        }

        public Criteria andBeanNameIn(List<String> values) {
            addCriterion("bean_name in", values, "beanName");
            return (Criteria) this;
        }

        public Criteria andBeanNameNotIn(List<String> values) {
            addCriterion("bean_name not in", values, "beanName");
            return (Criteria) this;
        }

        public Criteria andBeanNameBetween(String value1, String value2) {
            addCriterion("bean_name between", value1, value2, "beanName");
            return (Criteria) this;
        }

        public Criteria andBeanNameNotBetween(String value1, String value2) {
            addCriterion("bean_name not between", value1, value2, "beanName");
            return (Criteria) this;
        }

        public Criteria andIsActiveIsNull() {
            addCriterion("is_active is null");
            return (Criteria) this;
        }

        public Criteria andIsActiveIsNotNull() {
            addCriterion("is_active is not null");
            return (Criteria) this;
        }

        public Criteria andIsActiveEqualTo(Integer value) {
            addCriterion("is_active =", value, "isActive");
            return (Criteria) this;
        }

        public Criteria andIsActiveNotEqualTo(Integer value) {
            addCriterion("is_active <>", value, "isActive");
            return (Criteria) this;
        }

        public Criteria andIsActiveGreaterThan(Integer value) {
            addCriterion("is_active >", value, "isActive");
            return (Criteria) this;
        }

        public Criteria andIsActiveGreaterThanOrEqualTo(Integer value) {
            addCriterion("is_active >=", value, "isActive");
            return (Criteria) this;
        }

        public Criteria andIsActiveLessThan(Integer value) {
            addCriterion("is_active <", value, "isActive");
            return (Criteria) this;
        }

        public Criteria andIsActiveLessThanOrEqualTo(Integer value) {
            addCriterion("is_active <=", value, "isActive");
            return (Criteria) this;
        }

        public Criteria andIsActiveIn(List<Integer> values) {
            addCriterion("is_active in", values, "isActive");
            return (Criteria) this;
        }

        public Criteria andIsActiveNotIn(List<Integer> values) {
            addCriterion("is_active not in", values, "isActive");
            return (Criteria) this;
        }

        public Criteria andIsActiveBetween(Integer value1, Integer value2) {
            addCriterion("is_active between", value1, value2, "isActive");
            return (Criteria) this;
        }

        public Criteria andIsActiveNotBetween(Integer value1, Integer value2) {
            addCriterion("is_active not between", value1, value2, "isActive");
            return (Criteria) this;
        }

        public Criteria andContentIsNull() {
            addCriterion("content is null");
            return (Criteria) this;
        }

        public Criteria andContentIsNotNull() {
            addCriterion("content is not null");
            return (Criteria) this;
        }

        public Criteria andContentEqualTo(String value) {
            addCriterion("content =", value, "content");
            return (Criteria) this;
        }

        public Criteria andContentNotEqualTo(String value) {
            addCriterion("content <>", value, "content");
            return (Criteria) this;
        }

        public Criteria andContentGreaterThan(String value) {
            addCriterion("content >", value, "content");
            return (Criteria) this;
        }

        public Criteria andContentGreaterThanOrEqualTo(String value) {
            addCriterion("content >=", value, "content");
            return (Criteria) this;
        }

        public Criteria andContentLessThan(String value) {
            addCriterion("content <", value, "content");
            return (Criteria) this;
        }

        public Criteria andContentLessThanOrEqualTo(String value) {
            addCriterion("content <=", value, "content");
            return (Criteria) this;
        }

        public Criteria andContentLike(String value) {
            addCriterion("content like", value, "content");
            return (Criteria) this;
        }

        public Criteria andContentNotLike(String value) {
            addCriterion("content not like", value, "content");
            return (Criteria) this;
        }

        public Criteria andContentIn(List<String> values) {
            addCriterion("content in", values, "content");
            return (Criteria) this;
        }

        public Criteria andContentNotIn(List<String> values) {
            addCriterion("content not in", values, "content");
            return (Criteria) this;
        }

        public Criteria andContentBetween(String value1, String value2) {
            addCriterion("content between", value1, value2, "content");
            return (Criteria) this;
        }

        public Criteria andContentNotBetween(String value1, String value2) {
            addCriterion("content not between", value1, value2, "content");
            return (Criteria) this;
        }

        public Criteria andVersionIsNull() {
            addCriterion("version is null");
            return (Criteria) this;
        }

        public Criteria andVersionIsNotNull() {
            addCriterion("version is not null");
            return (Criteria) this;
        }

        public Criteria andVersionEqualTo(Integer value) {
            addCriterion("version =", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionNotEqualTo(Integer value) {
            addCriterion("version <>", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionGreaterThan(Integer value) {
            addCriterion("version >", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionGreaterThanOrEqualTo(Integer value) {
            addCriterion("version >=", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionLessThan(Integer value) {
            addCriterion("version <", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionLessThanOrEqualTo(Integer value) {
            addCriterion("version <=", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionIn(List<Integer> values) {
            addCriterion("version in", values, "version");
            return (Criteria) this;
        }

        public Criteria andVersionNotIn(List<Integer> values) {
            addCriterion("version not in", values, "version");
            return (Criteria) this;
        }

        public Criteria andVersionBetween(Integer value1, Integer value2) {
            addCriterion("version between", value1, value2, "version");
            return (Criteria) this;
        }

        public Criteria andVersionNotBetween(Integer value1, Integer value2) {
            addCriterion("version not between", value1, value2, "version");
            return (Criteria) this;
        }

        public Criteria andCreatedTimeIsNull() {
            addCriterion("created_time is null");
            return (Criteria) this;
        }

        public Criteria andCreatedTimeIsNotNull() {
            addCriterion("created_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedTimeEqualTo(Date value) {
            addCriterion("created_time =", value, "createdTime");
            return (Criteria) this;
        }

        public Criteria andCreatedTimeNotEqualTo(Date value) {
            addCriterion("created_time <>", value, "createdTime");
            return (Criteria) this;
        }

        public Criteria andCreatedTimeGreaterThan(Date value) {
            addCriterion("created_time >", value, "createdTime");
            return (Criteria) this;
        }

        public Criteria andCreatedTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("created_time >=", value, "createdTime");
            return (Criteria) this;
        }

        public Criteria andCreatedTimeLessThan(Date value) {
            addCriterion("created_time <", value, "createdTime");
            return (Criteria) this;
        }

        public Criteria andCreatedTimeLessThanOrEqualTo(Date value) {
            addCriterion("created_time <=", value, "createdTime");
            return (Criteria) this;
        }

        public Criteria andCreatedTimeIn(List<Date> values) {
            addCriterion("created_time in", values, "createdTime");
            return (Criteria) this;
        }

        public Criteria andCreatedTimeNotIn(List<Date> values) {
            addCriterion("created_time not in", values, "createdTime");
            return (Criteria) this;
        }

        public Criteria andCreatedTimeBetween(Date value1, Date value2) {
            addCriterion("created_time between", value1, value2, "createdTime");
            return (Criteria) this;
        }

        public Criteria andCreatedTimeNotBetween(Date value1, Date value2) {
            addCriterion("created_time not between", value1, value2, "createdTime");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNull() {
            addCriterion("created_by is null");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNotNull() {
            addCriterion("created_by is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedByEqualTo(String value) {
            addCriterion("created_by =", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotEqualTo(String value) {
            addCriterion("created_by <>", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThan(String value) {
            addCriterion("created_by >", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThanOrEqualTo(String value) {
            addCriterion("created_by >=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThan(String value) {
            addCriterion("created_by <", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThanOrEqualTo(String value) {
            addCriterion("created_by <=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLike(String value) {
            addCriterion("created_by like", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotLike(String value) {
            addCriterion("created_by not like", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByIn(List<String> values) {
            addCriterion("created_by in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotIn(List<String> values) {
            addCriterion("created_by not in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByBetween(String value1, String value2) {
            addCriterion("created_by between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotBetween(String value1, String value2) {
            addCriterion("created_by not between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedTimeIsNull() {
            addCriterion("updated_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdatedTimeIsNotNull() {
            addCriterion("updated_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdatedTimeEqualTo(Date value) {
            addCriterion("updated_time =", value, "updatedTime");
            return (Criteria) this;
        }

        public Criteria andUpdatedTimeNotEqualTo(Date value) {
            addCriterion("updated_time <>", value, "updatedTime");
            return (Criteria) this;
        }

        public Criteria andUpdatedTimeGreaterThan(Date value) {
            addCriterion("updated_time >", value, "updatedTime");
            return (Criteria) this;
        }

        public Criteria andUpdatedTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("updated_time >=", value, "updatedTime");
            return (Criteria) this;
        }

        public Criteria andUpdatedTimeLessThan(Date value) {
            addCriterion("updated_time <", value, "updatedTime");
            return (Criteria) this;
        }

        public Criteria andUpdatedTimeLessThanOrEqualTo(Date value) {
            addCriterion("updated_time <=", value, "updatedTime");
            return (Criteria) this;
        }

        public Criteria andUpdatedTimeIn(List<Date> values) {
            addCriterion("updated_time in", values, "updatedTime");
            return (Criteria) this;
        }

        public Criteria andUpdatedTimeNotIn(List<Date> values) {
            addCriterion("updated_time not in", values, "updatedTime");
            return (Criteria) this;
        }

        public Criteria andUpdatedTimeBetween(Date value1, Date value2) {
            addCriterion("updated_time between", value1, value2, "updatedTime");
            return (Criteria) this;
        }

        public Criteria andUpdatedTimeNotBetween(Date value1, Date value2) {
            addCriterion("updated_time not between", value1, value2, "updatedTime");
            return (Criteria) this;
        }

        public Criteria andUpdatedByIsNull() {
            addCriterion("updated_by is null");
            return (Criteria) this;
        }

        public Criteria andUpdatedByIsNotNull() {
            addCriterion("updated_by is not null");
            return (Criteria) this;
        }

        public Criteria andUpdatedByEqualTo(String value) {
            addCriterion("updated_by =", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByNotEqualTo(String value) {
            addCriterion("updated_by <>", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByGreaterThan(String value) {
            addCriterion("updated_by >", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByGreaterThanOrEqualTo(String value) {
            addCriterion("updated_by >=", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByLessThan(String value) {
            addCriterion("updated_by <", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByLessThanOrEqualTo(String value) {
            addCriterion("updated_by <=", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByLike(String value) {
            addCriterion("updated_by like", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByNotLike(String value) {
            addCriterion("updated_by not like", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByIn(List<String> values) {
            addCriterion("updated_by in", values, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByNotIn(List<String> values) {
            addCriterion("updated_by not in", values, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByBetween(String value1, String value2) {
            addCriterion("updated_by between", value1, value2, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByNotBetween(String value1, String value2) {
            addCriterion("updated_by not between", value1, value2, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andLastRechargeAmountIsNull() {
            addCriterion("last_recharge_amount is null");
            return (Criteria) this;
        }

        public Criteria andLastRechargeAmountIsNotNull() {
            addCriterion("last_recharge_amount is not null");
            return (Criteria) this;
        }

        public Criteria andLastRechargeAmountEqualTo(Long value) {
            addCriterion("last_recharge_amount =", value, "lastRechargeAmount");
            return (Criteria) this;
        }

        public Criteria andLastRechargeAmountNotEqualTo(Long value) {
            addCriterion("last_recharge_amount <>", value, "lastRechargeAmount");
            return (Criteria) this;
        }

        public Criteria andLastRechargeAmountGreaterThan(Long value) {
            addCriterion("last_recharge_amount >", value, "lastRechargeAmount");
            return (Criteria) this;
        }

        public Criteria andLastRechargeAmountGreaterThanOrEqualTo(Long value) {
            addCriterion("last_recharge_amount >=", value, "lastRechargeAmount");
            return (Criteria) this;
        }

        public Criteria andLastRechargeAmountLessThan(Long value) {
            addCriterion("last_recharge_amount <", value, "lastRechargeAmount");
            return (Criteria) this;
        }

        public Criteria andLastRechargeAmountLessThanOrEqualTo(Long value) {
            addCriterion("last_recharge_amount <=", value, "lastRechargeAmount");
            return (Criteria) this;
        }

        public Criteria andLastRechargeAmountIn(List<Long> values) {
            addCriterion("last_recharge_amount in", values, "lastRechargeAmount");
            return (Criteria) this;
        }

        public Criteria andLastRechargeAmountNotIn(List<Long> values) {
            addCriterion("last_recharge_amount not in", values, "lastRechargeAmount");
            return (Criteria) this;
        }

        public Criteria andLastRechargeAmountBetween(Long value1, Long value2) {
            addCriterion("last_recharge_amount between", value1, value2, "lastRechargeAmount");
            return (Criteria) this;
        }

        public Criteria andLastRechargeAmountNotBetween(Long value1, Long value2) {
            addCriterion("last_recharge_amount not between", value1, value2, "lastRechargeAmount");
            return (Criteria) this;
        }

        public Criteria andNeedPasswordIsNull() {
            addCriterion("need_password is null");
            return (Criteria) this;
        }

        public Criteria andNeedPasswordIsNotNull() {
            addCriterion("need_password is not null");
            return (Criteria) this;
        }

        public Criteria andNeedPasswordEqualTo(String value) {
            addCriterion("need_password =", value, "needPassword");
            return (Criteria) this;
        }

        public Criteria andNeedPasswordNotEqualTo(String value) {
            addCriterion("need_password <>", value, "needPassword");
            return (Criteria) this;
        }

        public Criteria andNeedPasswordGreaterThan(String value) {
            addCriterion("need_password >", value, "needPassword");
            return (Criteria) this;
        }

        public Criteria andNeedPasswordGreaterThanOrEqualTo(String value) {
            addCriterion("need_password >=", value, "needPassword");
            return (Criteria) this;
        }

        public Criteria andNeedPasswordLessThan(String value) {
            addCriterion("need_password <", value, "needPassword");
            return (Criteria) this;
        }

        public Criteria andNeedPasswordLessThanOrEqualTo(String value) {
            addCriterion("need_password <=", value, "needPassword");
            return (Criteria) this;
        }

        public Criteria andNeedPasswordLike(String value) {
            addCriterion("need_password like", value, "needPassword");
            return (Criteria) this;
        }

        public Criteria andNeedPasswordNotLike(String value) {
            addCriterion("need_password not like", value, "needPassword");
            return (Criteria) this;
        }

        public Criteria andNeedPasswordIn(List<String> values) {
            addCriterion("need_password in", values, "needPassword");
            return (Criteria) this;
        }

        public Criteria andNeedPasswordNotIn(List<String> values) {
            addCriterion("need_password not in", values, "needPassword");
            return (Criteria) this;
        }

        public Criteria andNeedPasswordBetween(String value1, String value2) {
            addCriterion("need_password between", value1, value2, "needPassword");
            return (Criteria) this;
        }

        public Criteria andNeedPasswordNotBetween(String value1, String value2) {
            addCriterion("need_password not between", value1, value2, "needPassword");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}